<?php declare(strict_types=1);

namespace App\Domains\Driver\Action;
use App\Domains\Driver\Model\Driver as Model;

abstract class CreateUpdateAbstract extends ActionAbstract
{
    /**
     * @return void
     */
    abstract protected function save(): void;

    public function handle(): Model
    {
        $this->data();
        $this->save();

        return $this->row;
    }

    /**
     * @return void
     */
    protected function data(): void
    {
        $this->dataName();
        $this->dataLicense();
        $this->dataUserId();
    }

    /**
     * @return void
     */
    protected function dataName(): void
    {
        $this->data['name'] = trim($this->data['name']);
    }

    /**
     * @return void
     */
    protected function dataLicense(): void
    {
        $this->data['license'] = trim($this->data['license']);
    }
}
