<?php declare(strict_types=1);

namespace App\Domains\Driver\ControllerApi;

use App\Domains\CoreApp\Controller\ControllerApiAbstract as CoreControllerApiAbstract;
use App\Domains\Driver\Model\Driver as Model;

abstract class ControllerApiAbstract extends CoreControllerApiAbstract
{
    protected ?Model $row;

    protected function row(int $id): Model
    {
        return $this->row = Model::query()
            ->byId($id)
            ->byUserOrManager($this->auth)
            ->firstOr(fn () => $this->exceptionNotFound(__('driver.error.not-found')));
    }
}
