<?php declare(strict_types=1);

namespace App\Domains\Driver\Fractal;

use App\Domains\Core\Fractal\FractalAbstract;
use App\Domains\Position\Model\Position as PositionModel;
use App\Domains\Driver\Model\Driver as Model;

class FractalFactory extends FractalAbstract
{

    protected function json(Model $row): array
    {
        return [
            'id' => $row->id,
            'name' => $row->name,
            'license' => $row->license,
            'enabled' => $row->enabled,
            'user' => $this->from('User', 'related', $row->user),
        ];
    }

    protected function map(Model $row): array
    {
        return [
            'id' => $row->id,
            'name' => $row->name,
            'license' => $row->license,
        ];
    }

    protected function related(Model $row): array
    {
        return [
            'id' => $row->id,
            'name' => $row->name,
            'license' => $row->license,
        ];
    }

    protected function simple(Model $row): array
    {
        return [
            'id' => $row->id,
            'name' => $row->name,
            'license' => $row->license,
        ];
    }
}
